package com.sun.corba.se.impl.encoding;

import com.sun.corba.se.spi.ior.iiop.GIOPVersion;
import java.nio.ByteBuffer;
import org.omg.CORBA.portable.BoxedValueHelper;
import java.io.Serializable;
import org.omg.CORBA.ContextList;
import org.omg.CORBA.Context;
import java.math.BigDecimal;
import java.io.IOException;
import org.omg.CORBA.NO_IMPLEMENT;
import org.omg.CORBA.Principal;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Object;
import org.omg.CORBA.ORB;
import java.io.OutputStream;

abstract class CDROutputStreamBase extends OutputStream
{
    protected CDROutputStream parent;
    
    CDROutputStreamBase() {
    }
    
    public void setParent(CDROutputStream parent) {
        this.parent = parent;
    }
    
    public void init(ORB orb, BufferManagerWrite bufferManagerWrite, byte b) {
        this.init(orb, false, bufferManagerWrite, b, true);
    }
    
    protected abstract void init(ORB p0, boolean p1, BufferManagerWrite p2, byte p3, boolean p4);
    
    public abstract void write_boolean(boolean p0);
    
    public abstract void write_char(char p0);
    
    public abstract void write_wchar(char p0);
    
    public abstract void write_octet(byte p0);
    
    public abstract void write_short(short p0);
    
    public abstract void write_ushort(short p0);
    
    public abstract void write_long(int p0);
    
    public abstract void write_ulong(int p0);
    
    public abstract void write_longlong(long p0);
    
    public abstract void write_ulonglong(long p0);
    
    public abstract void write_float(float p0);
    
    public abstract void write_double(double p0);
    
    public abstract void write_string(String p0);
    
    public abstract void write_wstring(String p0);
    
    public abstract void write_boolean_array(boolean[] p0, int p1, int p2);
    
    public abstract void write_char_array(char[] p0, int p1, int p2);
    
    public abstract void write_wchar_array(char[] p0, int p1, int p2);
    
    public abstract void write_octet_array(byte[] p0, int p1, int p2);
    
    public abstract void write_short_array(short[] p0, int p1, int p2);
    
    public abstract void write_ushort_array(short[] p0, int p1, int p2);
    
    public abstract void write_long_array(int[] p0, int p1, int p2);
    
    public abstract void write_ulong_array(int[] p0, int p1, int p2);
    
    public abstract void write_longlong_array(long[] p0, int p1, int p2);
    
    public abstract void write_ulonglong_array(long[] p0, int p1, int p2);
    
    public abstract void write_float_array(float[] p0, int p1, int p2);
    
    public abstract void write_double_array(double[] p0, int p1, int p2);
    
    public abstract void write_Object(org.omg.CORBA.Object p0);
    
    public abstract void write_TypeCode(TypeCode p0);
    
    public abstract void write_any(Any p0);
    
    public abstract void write_Principal(Principal p0);
    
    @Override
    public void write(int n) throws IOException {
        throw new NO_IMPLEMENT();
    }
    
    public abstract void write_fixed(BigDecimal p0);
    
    public void write_Context(Context context, ContextList list) {
        throw new NO_IMPLEMENT();
    }
    
    public abstract ORB orb();
    
    public abstract void write_value(Serializable p0);
    
    public abstract void write_value(Serializable p0, Class p1);
    
    public abstract void write_value(Serializable p0, String p1);
    
    public abstract void write_value(Serializable p0, BoxedValueHelper p1);
    
    public abstract void write_abstract_interface(Object p0);
    
    public abstract void start_block();
    
    public abstract void end_block();
    
    public abstract void putEndian();
    
    public abstract void writeTo(OutputStream p0) throws IOException;
    
    public abstract byte[] toByteArray();
    
    public abstract void write_Abstract(Object p0);
    
    public abstract void write_Value(Serializable p0);
    
    public abstract void write_any_array(Any[] p0, int p1, int p2);
    
    public abstract String[] _truncatable_ids();
    
    abstract void setHeaderPadding(boolean p0);
    
    public abstract int getSize();
    
    public abstract int getIndex();
    
    public abstract void setIndex(int p0);
    
    public abstract ByteBuffer getByteBuffer();
    
    public abstract void setByteBuffer(ByteBuffer p0);
    
    public abstract boolean isLittleEndian();
    
    public abstract ByteBufferWithInfo getByteBufferWithInfo();
    
    public abstract void setByteBufferWithInfo(ByteBufferWithInfo p0);
    
    public abstract BufferManagerWrite getBufferManager();
    
    public abstract void write_fixed(BigDecimal p0, short p1, short p2);
    
    public abstract void writeOctetSequenceTo(org.omg.CORBA.portable.OutputStream p0);
    
    public abstract GIOPVersion getGIOPVersion();
    
    public abstract void writeIndirection(int p0, int p1);
    
    abstract void freeInternalCaches();
    
    abstract void printBuffer();
    
    abstract void alignOnBoundary(int p0);
    
    public abstract void start_value(String p0);
    
    public abstract void end_value();
}
